## php-openswoole 25.2.0

=== CMakeLists.txt ===
PROJECT(libopenswoole)

ENABLE_LANGUAGE(ASM)
set(SWOOLE_VERSION 25.2.0)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -g")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
cmake_minimum_required(VERSION 2.8)

file(READ ./config.h SWOOLE_CONFIG_FILE)

set(CMAKE_MACOSX_RPATH 1)
set(SWOOLE_LINK_LIBRARIES pthread dl)

if (APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "-undefined dynamic_lookup")
    if (EXISTS "/usr/local/include")
        include_directories(BEFORE /usr/local/include)
    endif()
    if (EXISTS "/opt/homebrew/include")
        include_directories(BEFORE /opt/homebrew/include)
    endif()
    if (EXISTS "/usr/local/lib")
        link_directories(BEFORE /usr/local/lib)
    endif()
    if (EXISTS "/opt/homebrew/lib")
        link_directories(BEFORE /opt/homebrew/lib)
    endif()
else()
    list(APPEND SWOOLE_LINK_LIBRARIES rt crypt)
endif()

SET(CMAKE_BUILD_TYPE Debug)

# Code Coverage Configuration
add_library(coverage_config INTERFACE)

option(CODE_COVERAGE "Enable coverage reporting" OFF)
if(CODE_COVERAGE)
    message(STATUS "Open coverage")
    # --coverage => -fprofile-arcs -ftest-coverage
    target_compile_options(coverage_config INTERFACE
        -O0
        -g
        --coverage
    )
    if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.13)
        target_link_options(coverage_config INTERFACE --coverage)
    else()
        target_link_libraries(coverage_config INTERFACE --coverage)
    endif()
endif(CODE_COVERAGE)

file(GLOB_RECURSE SRC_LIST FOLLOW_SYMLINKS src/*.c src/*.cc
            thirdparty/boost/asmv1/combined.S
            thirdparty/boost/asm/combined.S
            thirdparty/hiredis/alloc.c
            thirdparty/hiredis/async.c
            thirdparty/hiredis/hiredis.c
            thirdparty/hiredis/net.c
            thirdparty/hiredis/read.c
            thirdparty/hiredis/sds.c
)
file(GLOB_RECURSE HEAD_FILES FOLLOW_SYMLINKS include/*.h)
file(GLOB_RECURSE HEAD_WAPPER_FILES FOLLOW_SYMLINKS include/wrapper/*.hpp)

SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_SOURCE_DIR}/lib)
SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

#message(STATUS "source=${SRC_LIST}")
#message(STATUS "header=${HEAD_FILES}")

add_definitions(-DHAVE_CONFIG_H)
# test
#add_definitions(-DSW_USE_THREAD_CONTEXT)

include_directories(BEFORE ./include ./include/wrapper ext-src/ ./)
SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

# find OpenSSL
if (DEFINED openssl_dir)
    include_directories(BEFORE ${openssl_dir}/include)
    link_directories(${openssl_dir}/lib)
else()
    find_package(OpenSSL)
    if (${OPENSSL_FOUND})
        message(STATUS "Found OpenSSL, ${OPENSSL_LIBRARIES}")
        include_directories(BEFORE ${OPENSSL_INCLUDE_DIR})
        list(APPEND SWOOLE_LINK_LIBRARIES ssl crypto)
    else()
        message(STATUS "Not found OpenSSL")
    endif()
endif()

if (DEFINED brotli_dir)
    include_directories(BEFORE ${brotli_dir}/include)
    link_directories(${brotli_dir}/lib)
endif()

foreach (LINE ${SWOOLE_CONFIG_FILE})
  if ("${LINE}" MATCHES "define SW_USE_CARES 1")
      message(STATUS "enable c-ares")
      list(APPEND SWOOLE_LINK_LIBRARIES cares)
  endif()
endforeach()

if (DEFINED enable_trace_log)
	add_definitions(-DSW_LOG_TRACE_OPEN)
endif()

execute_process(COMMAND php-config --includes OUTPUT_VARIABLE PHP_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND php-config --extension-dir OUTPUT_VARIABLE PHP_EXTENSION_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PHP_INCLUDES}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${PHP_INCLUDES}")

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    execute_process(COMMAND ldconfig -p OUTPUT_VARIABLE LDCONFIG_LIST OUTPUT_STRIP_TRAILING_WHITESPACE)
    #message(STATUS LDCONFIG_LIST)
    if (LDCONFIG_LIST MATCHES brotlienc)
         list(APPEND SWOOLE_LINK_LIBRARIES brotlienc)
    endif()

    if (LDCONFIG_LIST MATCHES brotlidec)
        list(APPEND SWOOLE_LINK_LIBRARIES brotlidec)
    endif()
endif()

# lib-openswoole
link_directories(${LIBRARY_OUTPUT_PATH})
add_library(lib-openswoole SHARED ${SRC_LIST})
set_target_properties(lib-openswoole PROPERTIES OUTPUT_NAME "openswoole" VERSION ${SWOOLE_VERSION})
target_link_libraries(lib-openswoole ${SWOOLE_LINK_LIBRARIES})
if(CODE_COVERAGE)
    target_link_libraries(lib-openswoole coverage_config gcov)
endif(CODE_COVERAGE)

# test_server
#set(TEST_SRC_LIST examples/cpp/test_server.cc)
#add_executable(test_server ${TEST_SRC_LIST})
#add_dependencies(test_server lib-openswoole)
#target_link_libraries(test_server openswoole pthread)

# co
#set(TEST_SRC_LIST examples/cpp/co.cc)
#add_executable(co ${TEST_SRC_LIST})
#add_dependencies(co lib-openswoole)
#target_link_libraries(co openswoole)

# ext-openswoole
file(GLOB ext_cxx_files ext-src/*.cc)
set(ext_src_list  ${ext_cxx_files}
        thirdparty/php/sockets/multicast.cc
        thirdparty/php/sockets/sendrecvmsg.cc
        thirdparty/php/sockets/conversions.cc
        thirdparty/php/sockets/sockaddr_conv.cc
        thirdparty/php/standard/proc_open.cc
        thirdparty/swoole_http_parser.c
        thirdparty/multipart_parser.c
        thirdparty/nghttp2/nghttp2_hd.c
        thirdparty/nghttp2/nghttp2_rcbuf.c
        thirdparty/nghttp2/nghttp2_helper.c
        thirdparty/nghttp2/nghttp2_buf.c
        thirdparty/nghttp2/nghttp2_mem.c
        thirdparty/nghttp2/nghttp2_hd_huffman.c
        thirdparty/nghttp2/nghttp2_hd_huffman_data.c
    )
add_library(ext-openswoole SHARED ${ext_src_list})
set_target_properties(ext-openswoole PROPERTIES PREFIX "")
set_target_properties(ext-openswoole PROPERTIES OUTPUT_NAME "openswoole")
add_dependencies(ext-openswoole lib-openswoole)

target_link_libraries(ext-openswoole openswoole)

#install
INSTALL(CODE "MESSAGE(\"Are you run command using root user?\")")
INSTALL(TARGETS ext-openswoole LIBRARY DESTINATION ${PHP_EXTENSION_DIR})
INSTALL(TARGETS lib-openswoole LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
INSTALL(FILES ${HEAD_FILES} DESTINATION include/openswoole)
INSTALL(FILES ${HEAD_WAPPER_FILES} DESTINATION include/openswoole/wrapper)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/config.h DESTINATION include/openswoole)

=== debian/changelog ===
php-openswoole (25.2.0-6+0~20251209.4+debian13~1.gbpe27800) unstable; urgency=medium

  ** SNAPSHOT build @e278003e743ff22bdd3ac890913b9b6c4ff9c7f5 **

  * UNRELEASED

 -- Ondřej Surý <ondrej@sury.org>  Tue, 09 Dec 2025 09:50:57 +0100

php-openswoole (25.2.0-6) unstable; urgency=medium

  * More adjustments for OpenSSL 1.1.x

 -- Ondřej Surý <ondrej@debian.org>  Tue, 09 Dec 2025 09:09:28 +0100

php-openswoole (25.2.0-5) unstable; urgency=medium

  * Use C++ static_cast for Ubuntu Bionic

 -- Ondřej Surý <ondrej@debian.org>  Tue, 09 Dec 2025 08:50:04 +0100

php-openswoole (25.2.0-4) unstable; urgency=medium

  * Limit the build to 64-bit architectures

 -- Ondřej Surý <ondrej@debian.org>  Tue, 09 Dec 2025 08:11:31 +0100

php-openswoole (25.2.0-3) unstable; urgency=medium

  * Limit the maximum version to PHP 8.4

 -- Ondřej Surý <ondrej@debian.org>  Tue, 09 Dec 2025 07:51:47 +0100

php-openswoole (25.2.0-2) unstable; urgency=medium

  * Build-Depend on php-all-dev (>= 2:97~) for PHP 8.5

 -- Ondřej Surý <ondrej@debian.org>  Sun, 23 Nov 2025 14:08:29 +0100

php-openswoole (25.2.0-1) unstable; urgency=medium

  * Update Build-Depends to php-all-dev (>= 2:95~)
  * New upstream version 25.2.0

 -- Ondřej Surý <ondrej@debian.org>  Sun, 09 Feb 2025 19:44:56 +0100

php-openswoole (22.1.2-2) unstable; urgency=medium

  * Bump default version to PHP 8.4

 -- Ondřej Surý <ondrej@debian.org>  Sat, 06 Jul 2024 17:33:55 +0200

php-openswoole (22.1.2-1) unstable; urgency=medium

  * Initial release.

 -- Ondřej Surý <ondrej@debian.org>  Mon, 13 May 2024 17:06:56 +0200

=== debian/control ===
Source: php-openswoole
Section: php
Priority: optional
Maintainer: Debian PHP PECL Maintainers <team+php-pecl@tracker.debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>
Build-Depends: debhelper (>= 10~),
               dh-php (>= 4~),
               libc-ares-dev,
               libcurl4-openssl-dev | libcurl-dev,
               libssl-dev,
	       libpq-dev,
               php-all-dev (>= 2:97~)
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/php-team/pecl/php-openswoole.git
Vcs-Browser: https://salsa.debian.org/php-team/pecl/php-openswoole
Homepage: http://pecl.php.net/package/openswoole

Package: php-openswoole
Architecture: all
Pre-Depends: php-common (>= 2:69~)
Depends: ${misc:Depends},
         ${pecl:Depends},
         ${php:Depends},
         ${shlibs:Depends}
Provides: ${pecl:Provides},
          ${php:Provides}
Breaks: ${pecl:Breaks}
Replaces: ${pecl:Replaces}
Suggests: ${pecl:Suggests}
Recommends: ${pecl:Recommends}
Description: OpenSwoole Coroutine Fiber Async Programming Framework for PHP
 Event-driven asynchronous and concurrent networking engine with high
 performance for PHP with following properties:
 .
  * event-driven
  * coroutine
  * asynchronous non-blocking
  * multi-thread reactor
  * multi-process worker
  * multi-protocol
  * millisecond timer
  * built-in tcp/http/websocket/http2 server
  * coroutine tcp/http/websocket client
  * coroutine mysql client
  * coroutine redis client
  * coroutine read/write file system
  * coroutine dns lookup
  * support IPv4/IPv6/UnixSocket/TCP/UDP
  * support SSL/TLS encrypted transmission
 .
 Open Swoole is a fork of orignal Swoole since release version v4.7.1.
 .
 This is empty package that depends on default PHP version.

Package: php-openswoole-all-dev
Architecture: all
Pre-Depends: php-common (>= 2:69~)
Depends: ${misc:Depends},
         ${pecl:Depends},
         ${php:Depends},
         ${shlibs:Depends}
Provides: ${pecl:Provides},
          ${php:Provides}
Breaks: ${pecl:Breaks}
Replaces: ${pecl:Replaces}
Suggests: ${pecl:Suggests}
Recommends: ${pecl:Recommends}
Description: OpenSwoole Coroutine Fiber Async Programming Framework for PHP
 Event-driven asynchronous and concurrent networking engine with high
 performance for PHP with following properties:
 .
  * event-driven
  * coroutine
  * asynchronous non-blocking
  * multi-thread reactor
  * multi-process worker
  * multi-protocol
  * millisecond timer
  * built-in tcp/http/websocket/http2 server
  * coroutine tcp/http/websocket client
  * coroutine mysql client
  * coroutine redis client
  * coroutine read/write file system
  * coroutine dns lookup
  * support IPv4/IPv6/UnixSocket/TCP/UDP
  * support SSL/TLS encrypted transmission
 .
 Open Swoole is a fork of orignal Swoole since release version v4.7.1.
 .
 This is empty package that depends on all PHP versions.

Package: php8.4-openswoole
Architecture: any-amd64 alpha arm64 loong64 mips64el ppc64 ppc64el s390x sparc64 riscv64
Pre-Depends: php-common (>= 2:69~)
Depends: ${misc:Depends},
         ${pecl:Depends},
         ${php:Depends},
         ${shlibs:Depends}
Provides: ${pecl:Provides},
          ${php:Provides}
Breaks: ${pecl:Breaks}
Replaces: ${pecl:Replaces}
Suggests: ${pecl:Suggests}
Recommends: ${pecl:Recommends}
Description: OpenSwoole Coroutine Fiber Async Programming Framework for PHP
 Event-driven asynchronous and concurrent networking engine with high
 performance for PHP with following properties:
 .
  * event-driven
  * coroutine
  * asynchronous non-blocking
  * multi-thread reactor
  * multi-process worker
  * multi-protocol
  * millisecond timer
  * built-in tcp/http/websocket/http2 server
  * coroutine tcp/http/websocket client
  * coroutine mysql client
  * coroutine redis client
  * coroutine read/write file system
  * coroutine dns lookup
  * support IPv4/IPv6/UnixSocket/TCP/UDP
  * support SSL/TLS encrypted transmission
 .
 Open Swoole is a fork of orignal Swoole since release version v4.7.1.

Package: php8.3-openswoole
Architecture: any-amd64 alpha arm64 loong64 mips64el ppc64 ppc64el s390x sparc64 riscv64
Pre-Depends: php-common (>= 2:69~)
Depends: ${misc:Depends},
         ${pecl:Depends},
         ${php:Depends},
         ${shlibs:Depends}
Provides: ${pecl:Provides},
          ${php:Provides}
Breaks: ${pecl:Breaks}
Replaces: ${pecl:Replaces}
Suggests: ${pecl:Suggests}
Recommends: ${pecl:Recommends}
Description: OpenSwoole Coroutine Fiber Async Programming Framework for PHP
 Event-driven asynchronous and concurrent networking engine with high
 performance for PHP with following properties:
 .
  * event-driven
  * coroutine
  * asynchronous non-blocking
  * multi-thread reactor
  * multi-process worker
  * multi-protocol
  * millisecond timer
  * built-in tcp/http/websocket/http2 server
  * coroutine tcp/http/websocket client
  * coroutine mysql client
  * coroutine redis client
  * coroutine read/write file system
  * coroutine dns lookup
  * support IPv4/IPv6/UnixSocket/TCP/UDP
  * support SSL/TLS encrypted transmission
 .
 Open Swoole is a fork of orignal Swoole since release version v4.7.1.

Package: php8.2-openswoole
Architecture: any-amd64 alpha arm64 loong64 mips64el ppc64 ppc64el s390x sparc64 riscv64
Pre-Depends: php-common (>= 2:69~)
Depends: ${misc:Depends},
         ${pecl:Depends},
         ${php:Depends},
         ${shlibs:Depends}
Provides: ${pecl:Provides},
          ${php:Provides}
Breaks: ${pecl:Breaks}
Replaces: ${pecl:Replaces}
Suggests: ${pecl:Suggests}
Recommends: ${pecl:Recommends}
Description: OpenSwoole Coroutine Fiber Async Programming Framework for PHP
 Event-driven asynchronous and concurrent networking engine with high
 performance for PHP with following properties:
 .
  * event-driven
  * coroutine
  * asynchronous non-blocking
  * multi-thread reactor
  * multi-process worker
  * multi-protocol
  * millisecond timer
  * built-in tcp/http/websocket/http2 server
  * coroutine tcp/http/websocket client
  * coroutine mysql client
  * coroutine redis client
  * coroutine read/write file system
  * coroutine dns lookup
  * support IPv4/IPv6/UnixSocket/TCP/UDP
  * support SSL/TLS encrypted transmission
 .
 Open Swoole is a fork of orignal Swoole since release version v4.7.1.

=== debian/rules ===
#!/usr/bin/make -f
export REPORT_EXIT_STATUS:=0
include /usr/share/dh-php/pkg-pecl.mk
PECL_CONFIGURE_MAINT_APPEND = \
	--enable-openswoole \
	--enable-sockets \
	--enable-cares \
	--enable-openssl \
	--enable-http2 \
	--enable-mysqlnd \
	--with-postgres \
	--enable-hook-curl

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)RC(\d*)$/$1rc$2/;s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/ \
https://pecl.php.net/package/openswoole .*/openswoole-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
